import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Mover here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mover extends Actor
{
    /**
     * Act - do whatever the Ninja wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //
    }

    /**
     * randomTurn() - To make an actor turn at random intervals, and by random amounts.
     */
    public void randomTurn(int max, int percent, int angle)
    {
        if (getRand(max) < percent)
        {
            turn(getRand(angle) - angle / 2);
        }
    }

    /**
     * turnEdge() - To make an actor turn when atWorldEdge() returns true.
     */
    public void turnEdge(int angle)
    {
        if (atWorldEdge())
        {
            turn(angle);
        }
    }

    /**
     * atWorldEdge() - Test if we are close to one of the edges of the
     *                  world and return true if we are.
     */
    public boolean atWorldEdge()
    {
        World w = getWorld();
        if (getX() < 20 || getX() > w.getWidth() - 20)
        {
            //System.out.println("At left or right edge");
            return true;
        }
        if (getY() < 20 || getY() > w.getHeight() - 20)
        {
            //System.out.println("At top or bottom edge");
            return true;
        }
        return false;
    }

    /**
     * getRand() - To find a random number up to a specified integer with shorter notation.
     */
    public int getRand(int max)
    {
        return Greenfoot.getRandomNumber(max);
    }

    /**
     * canSee() - To determine whether an Actor has stumbled upon another.
     */
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;
    }

    /**
     * canSeeFar() - To determine whether an Actor is near an Object.
     */
    public boolean canSeeFar(Class clss)
    {
        Actor actor = getOneIntersectingObject(clss);
        return actor != null;
    }

    /**
     * eat() - To make one Actor eliminate another.
     */
    public void eat(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if (actor != null) {
            getWorld().removeObject(actor);
        }
    }

    /**
     * avoidObject() - To prevent Actors from crashing into Objects in the environment.
     */
    public void avoidObject(Class clss)
    {
        if (canSee(clss))
        {
            turn(-17);
        }
    }
}
