import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class NinjaCat here.
 * 
 * @author (Cameron Petras) 
 * @version (1.1.2 - 9/10/12)
 */
public class NinjaCat extends Ninja
{
    private String facing = "right";
    private World w;
    public NinjaCat()
    {

    }

    protected void addedToWorld(World world)
    {
        w = world;
    }

    /**
     * Act - do whatever the NinjaCat wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //move(2);
        //turnEdge(17);
        //avoidObject(Cottage.class);
        //randomTurn(101, 20, 70);
        List p = w.getObjects(Peasant.class);
        List e = w.getObjects(Enemies.class);

        control();
        edgeWarp();
        ninjaCatStrike(EvilNinja.class, "Huah.wav");
        ninjaCatStrike(TeleNinja.class, "Huah.wav");

        if(p.size() == 0)
        {
            setLocation(450, 300);
            setRotation(0);
            setImage("failMessage.png");
            Greenfoot.stop();
        }
        
        if(e.size() == 0)
        {
            Greenfoot.stop();
        }
    }

    /**
     * ninjaCatStrike() - To call canSeeFar(), and if returned true, call eat().
     */
    public void ninjaCatStrike(Class clss, String sound)
    {
        if (canSee(clss))
        {
            eat(clss);
            Greenfoot.playSound("Metal Hit.wav");
            Greenfoot.playSound(sound);
            NinjaWorld nw = (NinjaWorld) getWorld();
            nw.killOne();
            if (nw.getNinjaCount() >= 6)
            {
                System.out.println("Congratulations! The village is safe.");
                Greenfoot.stop();
            }
        }
    }

    /**
     * control() - To make NinjaCat move on key press.
     */
    public void control()
    {
        if (Greenfoot.isKeyDown("up"))
        {
            setLocation(getX(), getY() - 5);
        }
        if (Greenfoot.isKeyDown("down"))
        {
            setLocation(getX(), getY() + 5);
        }
        if (Greenfoot.isKeyDown("left"))
        {
            move(-5);
            runLeft();
            facing = "left";
        }
        if (Greenfoot.isKeyDown("right"))
        {
            move(5);
            runRight();
            facing = "right";
        }
        else
        {
            updateImage();
        }
    }

    private GreenfootImage stand1 = (new GreenfootImage("NinjaCatStand1.png"));
    private GreenfootImage stand2 = (new GreenfootImage("NinjaCatStand2.png"));
    private GreenfootImage stand3 = (new GreenfootImage("NinjaCatStand3.png"));
    private GreenfootImage stand4 = (new GreenfootImage("NinjaCatStand4.png"));
    private GreenfootImage stand5 = (new GreenfootImage("NinjaCatStand5.png"));
    private GreenfootImage stand6 = (new GreenfootImage("NinjaCatStand6.png"));
    private GreenfootImage stand7 = (new GreenfootImage("NinjaCatStand7.png"));
    private GreenfootImage NCSL1 = (new GreenfootImage("NCSL1.png"));
    private GreenfootImage NCSL2 = (new GreenfootImage("NCSL2.png"));
    private GreenfootImage NCSL3 = (new GreenfootImage("NCSL3.png"));
    private GreenfootImage NCSL4 = (new GreenfootImage("NCSL4.png"));
    private GreenfootImage NCSL5 = (new GreenfootImage("NCSL5.png"));
    private GreenfootImage NCSL6 = (new GreenfootImage("NCSL6.png"));
    private GreenfootImage NCSL7 = (new GreenfootImage("NCSL7.png"));
    /**
     * To move NinjaCat's tail.
     */
    public void animateStand()
    {
        if (facing == "left")
        {
            if (getImage() == NCSL1)
            {
                setImage(NCSL2);
            }
            else if (getImage() == (NCSL2))
            {
                setImage(NCSL3);
            }
            else if (getImage() == (NCSL3))
            {
                setImage(NCSL4);
            }
            else if (getImage() == (NCSL4))
            {
                setImage(NCSL5);
            }
            else if (getImage() == (NCSL5))
            {
                setImage(NCSL6);
            }
            else if (getImage() == (NCSL6))
            {
                setImage(NCSL7);
            }
            else
            {
                setImage(NCSL1);
            }
        }
        else if (facing == "right")
        {
            if (getImage() == stand1)
            {
                setImage(stand2);
            }
            else if (getImage() == (stand2))
            {
                setImage(stand3);
            }
            else if (getImage() == (stand3))
            {
                setImage(stand4);
            }
            else if (getImage() == (stand4))
            {
                setImage(stand5);
            }
            else if (getImage() == (stand5))
            {
                setImage(stand6);
            }
            else if (getImage() == (stand6))
            {
                setImage(stand7);
            }
            else
            {
                setImage(stand1);
            }
        }
    }

    private int standTimer;
    /**
     * To make tail animation smoother
     */
    public void updateImage()
    {
        if (standTimer == 5)
        {
            animateStand();
            standTimer = 0;
        }
        else
        {
            standTimer++;
        }
    }

    private GreenfootImage run1 = new GreenfootImage("NinjaCatRun1.png");
    private GreenfootImage run2 = new GreenfootImage("NinjaCatRun2.png");
    private GreenfootImage run3 = new GreenfootImage("NinjaCatRun3.png");
    private GreenfootImage run4 = new GreenfootImage("NinjaCatRun4.png");
    /**
     * To animate NinjaCat running right.
     */
    public void runRightAni()
    {
        if (getImage() == run1)
        {
            setImage(run2);
        }
        else if (getImage() == run2)
        {
            setImage(run3);
        }
        else if (getImage() == run3)
        {
            setImage(run4);
        }
        else
        {
            setImage(run1);
        }
    }
    private int runTimer;
    /**
     * To make run animation smoother
     */
    public void runRight()
    {
        if (runTimer == 5)
        {
            runRightAni();
            runTimer = 0;
        }
        else
        {
            runTimer++;
        }
    }

    private GreenfootImage runL1 = new GreenfootImage("NCRL1.png");
    private GreenfootImage runL2 = new GreenfootImage("NCRL2.png");
    private GreenfootImage runL3 = new GreenfootImage("NCRL3.png");
    private GreenfootImage runL4 = new GreenfootImage("NCRL4.png");
    /**
     * To animate NinjaCat running left.
     */
    public void runLeftAni()
    {
        if (getImage() == runL1)
        {
            setImage(runL2);
        }
        else if (getImage() == runL2)
        {
            setImage(runL3);
        }
        else if (getImage() == runL3)
        {
            setImage(runL4);
        }
        else
        {
            setImage(runL1);
        }
    }

    private int runTimerL;
    /**
     * To make run animation smoother
     */
    public void runLeft()
    {
        if (runTimerL == 5)
        {
            runLeftAni();
            runTimerL = 0;
        }
        else
        {
            runTimerL++;
        }
    }
}
