import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * NinjaWorld - An area NinjaCat and his adversaries (EvilNinja and TeleNinja) can move within.
 * 
 * @author (Cameron Petras) 
 * @version (1.1.0 - 9/9/12)
 */
public class NinjaWorld extends World
{
    private int count;
    private int ninjaCount;
    private int Peas;
    /**
     * Constructor for objects of class NinjaWorld.
     * 
     */
    public NinjaWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(900, 600, 1);
        prepare();
    }
    
    public void prepare()
    {
        addObject(new NinjaCat(), 200, 300);
        addObject(new Cottage(), 50, 300);
        makeEvilNinjas(3);
        makeTeleNinjas(3);
        manyPeas(4, 150, 150);
        manyPeas(4, 150, 450);
    }
    
    /**
     * to make EvilNinjas
     */
    public void makeEvilNinjas(int numNinjas)
    {
        int i = 0;
        while (i < numNinjas)
        {
            addObject(new EvilNinja(), 700, (i + 1) * 150);
            i++;
        }
    }
    
    /**
     * to make TeleNinjas
     */
    public void makeTeleNinjas(int numNinjas)
    {
        int i = 0;
        while (i < numNinjas)
        {
            addObject(new TeleNinja(), 500, (i + 1) * 150);
            i++;
        }
    }    
        
    public void manyPeas(int peas, int peasX, int peasY)
    {
        for(Peas = 0; Peas < peas; Peas++)
        {
            addObject(new Peasant(), peasX, peasY);
        }
    }
    
    public void addOne()
    {
        count++;
    }
    
    public int getCount()
    {
        return count;
    }
    
    public void killOne()
    {
        ninjaCount++;
    }
    
    public int getNinjaCount()
    {
        return ninjaCount;
    }
}
